{------------------------------------------------------------------------}
{                                  _ _
         _                        \    \
     ---\ \------------------------\    \--------------------------
   ======\ \===\ \=\    _\=\ \======| |\ \==\ \==\ \==\  _ _\========
          | \  | |  | |_    | |     | |_\ \  \ \  \ \  \ \_ _
          |  \ | |  |  _\   | |     |  _ _ \  \ \  \ \  \_ _  \     
          | |\\| |  | |     | |     | |  / /  / /  / /      / /
          | | \  |  | | _   | | _ _ | | / /  / /_ / /   _ _/ /
   ======/ /==/ /==/    /==/      /=| |/ /==/      /==/     /========
     ---/_/------------------------/    /--------------------------
                                  /_ _ /
 NelBus
 (c) 1999 Marco A. Alvarado

 Encuentra los archivos que contienen cierto texto y cita el contenido.}
{------------------------------------------------------------------------}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, FileCtrl, StdCtrls, Menus, ExtCtrls, Buttons, ComCtrls, shellapi;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Programa1: TMenuItem;
    Cierra1: TMenuItem;
    Bevel1: TBevel;
    Edit1: TEdit;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Button1: TButton;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    Button2: TButton;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Button3: TButton;
    Acercade1: TMenuItem;
    procedure Cierra1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FileListBox1DblClick(Sender: TObject);
    procedure Acercade1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    encontrados : longint;  {cantidad de archivos con apariciones}
    procedure limpia_stringgrid1;
    procedure activa_busqueda;
    procedure desactiva_busqueda;
    procedure maneja_excepcion (Sender: TObject; E: Exception);
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

const
  tamano_bloque = 16384;  {16kb} {es el tamao en caracteres del bloque
    de carga; se puede aumentar el valor para acelerar la bsqueda
    (no abuse!)}
  tamano_cita = 50;  {define el tamao mximo del bloque de cita}

var
  archivo : file;  {es un archivo de cualquier tipo; es el archivo donde
    se busca el texto}
  bloque : array [1..tamano_bloque] of char;  {almacena temporalmente una
    parte o todo el contenido del archivo; acelera la bsqueda, porque
    hace el trabajo en la memoria y no en el disco}
  indice_bloque,  {es la posicin en el bloque}
  cuenta_bloque,  {es la cantidad de caracteres cargados en el bloque; no
    todos los archivos miden ms del tamao del bloque, as que slo se
    carga una parte de ellos}
  bloques_leidos : longint;  {es la cantidad de bloques ledos del
    archivo}
  texto : string;  {es el texto que ser buscado}
  indice_texto,  {es la posicin en el texto}
  tamano_texto : longint;  {es la cantidad de caracteres en el texto}
  detiene : boolean;  {indica si se debe detener la bsqueda}
  bloque_cita : array [1..tamano_cita] of char;  {almacena los caracteres
    de la cita}
  indice_cita,  {es la posicin en el bloque de cita}
  cuenta_cita : longint;  {es la cantidad de caracteres cargados en el
    bloque de cita}

function abre_archivo (nombre : string) : boolean;
begin
{$i-}  {desactiva las excepciones de entrada y salida; en otras palabras:
  evita que se caiga el programa por un error de archivo}
  assignfile (archivo, nombre);
  reset (archivo, 1);  {abre el archivo para lectura; lee un byte a la
    vez (1 byte = 1 char)}
  abre_archivo := ioresult = 0;  {es true si no hubo error}
{$i+}
  indice_bloque := 1;  {prepara las variables}
  cuenta_bloque := 0;
  bloques_leidos := 0;
  indice_texto := 1;
end;

function cierra_archivo : boolean;
begin
{$i-}
  closefile (archivo);
  cierra_archivo := ioresult = 0;  {es true si no hubo error}
{$i+}
end;

function lee_bloque : boolean;
begin
{$i-}
  blockread (archivo, bloque, tamano_bloque, cuenta_bloque);
  lee_bloque := (ioresult = 0) and (cuenta_bloque > 0);  {es true si no
    hubo error y ley al menos un caracter}
{$i+}
  indice_bloque := 1;  {regresa al inicio del bloque}
  if cuenta_bloque > 0 then inc (bloques_leidos);  {suma un bloque}
end;

function busca_primera : boolean;  {regresa true si encuentra una
  siguiente aparicin de la primera letra del texto}
begin

  if (cuenta_bloque = 0) or (tamano_texto = 0) then
  begin
    busca_primera := false;
    exit;  {si el bloque o el texto estn vacos no hay nada que hacer}
  end;

  while bloque [indice_bloque] <> texto [1] do  {termina cuando encuentra
    la primera letra del texto}
  begin
    inc (indice_bloque);  {avanza el ndice al siguiente caracter}

    if indice_bloque > cuenta_bloque then
    begin  {si acaba el bloque carga otro ms}
      if not lee_bloque then break;  {si no pudo cargarlo sale de este
        while}
    end;

  end;

  busca_primera := bloque [indice_bloque] = texto [1];
end;

function compara_texto : boolean;  {regresa true si los caracteres en el
  bloque y el texto son iguales}
begin

  if (cuenta_bloque = 0) or (tamano_texto = 0) then
  begin
    compara_texto := false;
    exit;  {si el bloque o el texto estn vacos no hay nada que hacer}
  end;

  while (bloque [indice_bloque] = texto [indice_texto]) and
    (indice_texto <= tamano_texto) do  {termina cuando uno de los
      caracteres del bloque difiere del texto, o los ha comparado todos}
  begin
    inc (indice_texto);  {avanza en el texto}
    inc (indice_bloque);  {avanza en el bloque}

    if indice_bloque > cuenta_bloque then
    begin  {si acaba el bloque carga otro ms}
      if not lee_bloque then break;  {si no pudo cargarlo sale de este
        while}
    end;

  end;

  compara_texto := indice_texto > tamano_texto;  {si acab el texto es
    porque todos los caracteres son iguales}
  indice_texto := 1;  {regresa al inicio del texto}
end;

function lee_cita (posicion, radio : longint) : string;  {lee los
  caracteres antes y despus del texto en la posicin requerida del
  archivo, en un radio determinado}

  var
    anterior,
    inicio,
    fin,
    indice : longint;
    cita : string;  {es el resultado}

begin
{$i-}
  anterior := filepos (archivo);  {salva la posicin actual}

  if ioresult <> 0 then
  begin
    seek (archivo, anterior);  {recupera la posicin anterior}
    lee_cita := '';
    exit;
  end;
{$i+}

  cita := '';
  if posicion - radio - 1 < 0 then
    inicio := 0
  else
    inicio := posicion - radio - 1;  {calcula el inicio}
{$i-}
  seek (archivo, inicio);
  blockread (archivo, bloque_cita, tamano_cita, cuenta_cita);

  if ioresult <> 0 then
  begin
    seek (archivo, anterior);  {recupera la posicin anterior}
    lee_cita := '';
    exit;
  end;
{$i+}

  indice_cita := 0;

  for indice := inicio to posicion - 2 do
  begin
    inc (indice_cita);
    cita := cita + bloque_cita [indice_cita];  {agrega los primeros
      caracteres}
  end;

  cita := cita + '[' + texto + ']';  {agrega el texto marcado}
  if posicion + tamano_texto + radio - 2 > filesize (archivo) - 1 then
    fin := filesize (archivo) - 1
  else
    fin := posicion + tamano_texto + radio - 2;  {calcula el fin}
{$i-}
  seek (archivo, posicion + tamano_texto - 1);
  blockread (archivo, bloque_cita, tamano_cita, cuenta_cita);

  if ioresult <> 0 then
  begin
    seek (archivo, anterior);  {recupera la posicin anterior}
    lee_cita := '';
    exit;
  end;
{$i+}

  indice_cita := 0;

  for indice := posicion + tamano_texto - 1 to fin do
  begin
    inc (indice_cita);
    cita := cita + bloque_cita [indice_cita];  {agrega los ltimos
      caracteres}
  end;

{$i-}
  seek (archivo, anterior);  {recupera la posicin anterior}
{$i+}
  lee_cita := cita;  {regresa el resultado}
end;

procedure revisa_archivo (nombre : string);

  var
    mencionado : boolean;  {bandera que sirve para no repetir resultados
      de la bsqueda}
    posicion,  {es la posicin en el archivo donde comienza la aparicin
      del texto}
    apariciones : longint;  {cantidad de apariciones del texto}

begin
  form1. statusbar1. panels [0]. text := 'Revisando: ' + nombre;
  texto := form1. edit1. text;
  tamano_texto := length (texto);
  mencionado := false;
  apariciones := 0;
  if detiene then exit;

  if abre_archivo (nombre) then
  begin;
    lee_bloque;  {lee el primer bloque}

    if detiene then
    begin
      cierra_archivo;
      exit;
    end;

    while busca_primera do  {busca todas las posibles apariciones del
      texto}
    begin

      if detiene then
      begin
        cierra_archivo;
        exit;
      end;

      if compara_texto then
      begin  {Bravo, viva, lo encontr!... registra el hallazgo.}
        inc (apariciones);
        form1. statusbar1. panels [0]. text := 'Revisando: ' + nombre +
          '  Apariciones: ' + inttostr (apariciones);

        with form1. stringgrid1 do
        begin

          if not mencionado then
          begin
            inc (form1. encontrados);
            if rowcount > 2 then
              rowcount := rowcount + 1;  {divide la informacin con
                otra fila}
            cells [0, rowcount - 1] := nombre;
            cells [3, rowcount - 1] := inttostr (filesize (archivo));
            mencionado := true;
          end;

          posicion := (bloques_leidos - 1) * tamano_bloque +
            indice_bloque - tamano_texto;  {calcula la posicin donde
              comienza el texto}
          cells [1, rowcount - 1] := inttostr (posicion);
          cells [2, rowcount - 1] := lee_cita (posicion,
            form1. trackbar1. position);
          rowcount := rowcount + 1;  {coloca otra fila}
        end;

      end;

      application. processmessages;  {permite que trabajen los objetos
        de la aplicacin}
    end;

    cierra_archivo;
  end;

end;

{------------------------------------------------------------------------}

procedure TForm1.Cierra1Click(Sender: TObject);
begin
  close;  {cierra el form principal, y por lo tanto la aplicacin}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  application. onexception := maneja_excepcion;  {establece el manejador
    de excepciones}

  encontrados := 0;

  with stringgrid1 do
  begin
    cells [0, 0] := 'Ruta';  {nombra las columnas de stringgrid1}
    cells [1, 0] := 'Posiciones';
    cells [2, 0] := 'Citas';
    cells [3, 0] := 'Tamao';
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  desactiva_busqueda;

  if checkbox1. checked then
  begin
    encontrados := 0;
    limpia_stringgrid1;
  end;

  detiene := false;
  revisa_archivo (filelistbox1. filename);
  if encontrados = 0 then
    statusbar1. panels [0]. text := ''
  else
    statusbar1. panels [0]. text := 'Archivos encontrados: ' +
      inttostr (form1. encontrados);
  activa_busqueda;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  if stringgrid1. cells [col, row] = '' then canselect := false;
end;

procedure TForm1.Button1Click(Sender: TObject);

  var
    indice : longint;

begin
  desactiva_busqueda;

  if checkbox1. checked then
  begin
    encontrados := 0;
    limpia_stringgrid1;
  end;

  with filelistbox1 do
  begin
    detiene := false;

    for indice := 0 to items. count - 1 do
    begin
      if directory [length (directory)] = '\' then
        revisa_archivo (directory + items. strings [indice])
      else
        revisa_archivo (directory + '\' + items. strings [indice]);
      if detiene then break;
    end;

  end;

  if encontrados = 0 then
    statusbar1. panels [0]. text := ''
  else
    statusbar1. panels [0]. text := 'Archivos encontrados: ' +
      inttostr (form1. encontrados);
  activa_busqueda;
end;

procedure tform1. limpia_stringgrid1;

  var
    indice : longint;

begin
  statusbar1. panels [0]. text := 'Borrando la tabla...';

  with stringgrid1 do
  begin
    for indice := 0 to colcount - 1 do
      stringgrid1. cols [indice]. clear;  {borra el contenido de cada
        columna}
    rowcount := 2;  {reduce la cantidad de filas; esta asignacin no
      borra el contenido del stringgrid1, como uno podra pensar; por eso
      se necesita el for anterior}
    cells [0, 0] := 'Ruta';  {nombra las columnas de stringgrid1}
    cells [1, 0] := 'Posiciones';
    cells [2, 0] := 'Citas';
    cells [3, 0] := 'Tamao';
  end;

  statusbar1. panels [0]. text := '';
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if length (edit1. text) = 0 then
    label2. caption := ''
  else
    label2. caption := 'Caracteres: ' + inttostr (length (edit1. text));
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  label3. caption := 'Radio de citas: ' + inttostr (trackbar1. position);
end;

procedure tform1. activa_busqueda;
begin
  Edit1. enabled := true;
  DriveComboBox1. enabled := true;
  DirectoryListBox1. enabled := true;
  Button1. enabled := true;
  FilterComboBox1. enabled := true;
  FileListBox1. enabled := true;
  Button2. enabled := true;
  CheckBox1. enabled := true;
  TrackBar1. enabled := true;
  Button3. enabled := false;
end;

procedure tform1. desactiva_busqueda;
begin
  Edit1. enabled := false;
  DriveComboBox1. enabled := false;
  DirectoryListBox1. enabled := false;
  Button1. enabled := false;
  FilterComboBox1. enabled := false;
  FileListBox1. enabled := false;
  Button2. enabled := false;
  CheckBox1. enabled := false;
  TrackBar1. enabled := false;
  Button3. enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  detiene := true;
end;

procedure TForm1.FileListBox1DblClick(Sender: TObject);
begin
  statusbar1. panels [0]. text := 'Abriendo el archivo ' +
    filelistbox1. filename + '...';
  shellexecute (handle, 'open', pchar (filelistbox1. filename), '',
    pchar (filelistbox1. directory), sw_show);  {abre un programa o un
      documento asociado; est en la unidad shellapi}
  statusbar1. panels [0]. text := '';
end;

procedure tform1. maneja_excepcion (Sender: TObject; E: Exception);

  var
    resultado : word;

begin
  if messagedlg (
    'Desea continuar usando esta aplicacin?',
    mterror, mbokcancel, 0) = mrcancel then close;  {Cierra la aplicacin
      si el usuario cancela}
end;

procedure TForm1.Acercade1Click(Sender: TObject);
begin
  form2. show;
end;

end.
